package com.qmth.distributed.print.api.mark;

import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.teachcloud.common.contant.SystemConstant;
import com.qmth.teachcloud.common.util.Result;
import com.qmth.teachcloud.common.util.ResultUtil;
import com.qmth.teachcloud.mark.bean.archivescore.ArchiveScoreQuery;
import com.qmth.teachcloud.mark.bean.archivescore.ArchiveStudentQuery;
import com.qmth.teachcloud.mark.bean.archivescore.ScoreReportVo;
import com.qmth.teachcloud.mark.service.MarkPaperService;
import com.qmth.teachcloud.mark.service.MarkStudentService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * <p>
 * 成绩管理 前端控制器
 * </p>
 *
 * @author xf
 * @since 2023-09-22
 */
@Api(tags = "成绩管理")
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + SystemConstant.PREFIX_URL_MARK + "/archive")
public class MarkArchiveController {

	@Autowired
	private MarkPaperService markPaperService;
	@Autowired
	private MarkStudentService markStudentService;

	@ApiOperation(value = "成绩管理列表")
	@RequestMapping(value = "score/list", method = RequestMethod.POST)
	public Result scoreList(@Validated ArchiveScoreQuery query) {
		return ResultUtil.ok(markPaperService.scoreList(query));
	}

	@ApiOperation(value = "班级详情列表")
	@RequestMapping(value = "student/list", method = RequestMethod.POST)
	public Result studentList(@Validated ArchiveStudentQuery query) {
		return ResultUtil.ok(markStudentService.studentList(query));
	}

	@ApiOperation(value = "成绩导出")
	@RequestMapping(value = "score/export", method = RequestMethod.POST)
	public void scoreExport(@Validated ArchiveStudentQuery query, HttpServletResponse response) {
		markStudentService.scoreExport(query, response);
	}
	
	@ApiOperation(value = "成绩报告")
	@RequestMapping(value = "score/report", method = RequestMethod.POST)
	public ScoreReportVo scoreReport(@RequestParam Long examId,@RequestParam String paperNumber) {
		return markStudentService.scoreReport(examId, paperNumber);
	}
}
